#
# The Quick and Dirty Search Engine and Indexer
#
# (C) Copyright 2001 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

from DocumentTemplate.DT_Util import *
from DocumentTemplate.DT_String import String
from DateTime.DateTime import DateTime
import Acquisition
import md5
import string

class IndexerTag:
	"""
	Feed stuff to the Indexer
	"""

	name='indexer'
	blockContinuations=()

	# err We don't have any parameters... cool eh?
	def __init__(self, blocks):
		tname, args, section = blocks[0]
		self.section=section

	# Find someone to do something for us..
	def findTextIndexer(self, root):
		while root is not None:
			if hasattr(root,'objectValues'):
				for o in root.objectValues():
					try:
						if (hasattr(o,'meta_type') and
							o.meta_type=='Text Indexer'):
							return o
					except:
						pass
			if hasattr(root,'aq_parent'):
				root=root.aq_parent
			else:
				root=None
		return None

	def render(self, md):
		""" Well we just index the content and return the block """
		us=md.this

		_Indexer=self.findTextIndexer(us)

		if _Indexer:
			thisText=string.strip(render_blocks(self.section.blocks,md))
			_Indexer.addArticleToIndexer(us.absolute_url(),thisText)

		return self.section(md.this,md)			

	__call__=render


		
String.commands['indexer'] = IndexerTag
